Unit EvoStoreSrc;

interface
Uses
    controls,
    forms, SysUtils, Windows,  graphics,
    classes, cybmanip,
    registry;

const
            TitleString = 'Borises Life';

            GSOgre = 0;
            GSAnt = 1;
            GSBird = 2;
            GSFlower1 = 3;
            GSFlower2 = 4;
            GSButterFly = 5;
            GSTree = 6;
            GSTigger = 7;
            GSPooh = 8;
            GSEeyore = 9;
            GSPiglet = 10;
            GSBlueBird = 11;

            isMale = 11;
            isFemale = 12;

            SpareCanvasesID = 0;
            AnimalStatePicsID = 1;
            SexPicsID = 2;

      efInfluencedistance = 0;
        efNumberchildren  = 1;
              efMinenergy = 2;
              efMaxenergy = 3;
                 efEnergy = 4;
               efStepsize = 5;
               efFoodlist = 6;
          SuccefStartingcount = succ(efFoodlist);

      maxInfluencedistance = 10;
        maxNumberchildren  = 20;
              maxMinenergy = 1000;
              maxMaxenergy = 1000;
                 maxEnergy = 1000;
               maxStepsize = 20;
          maxStartingcount = 500;

      minInfluencedistance = 1;
        minNumberchildren  = 1;
              minMinenergy = 1;
              minMaxenergy = 2;
                 minEnergy = 1;
               minStepsize = 1;
          minStartingcount = 1;

      savModeConfigureStd=1; //right click in explorer and choose configure
      savModeConfigure   =2; //config dialog from screensaver properties dialog
      savModeExecute     =3; //run in fullscreen
      savModePreview     =4; //run in preview window
      savModeSetPwd      =5; //show change password dialog

Type

  TSpareCanvasTypes = (scDblBuffer, scScrollBuffer, scPreviewBuffer);
  TSpareCanvases = array[scDblBuffer..scPreviewBuffer] of graphics.tbitmap;

  TAnimalStates = (taIdle, taBreeding, taBeingEaten, taEating,  taCompeting, taDead);
  TAnimalStatePics = array[taIdle..taCompeting] of graphics.tbitmap;
  TAnimalStateStrings = array[taIdle..taCompeting] of String;

  TSexes = (esMale, esFemale);
  TSexPics = array[esMale .. esFemale] of graphics.tbitmap;

  TCreatureCensus = array[GSOgre..GSBlueBird] of integer;
  PCreatureCensus = ^TCreatureCensus;

    tSaverOptions = record
      DialogPage : Integer;
      CreaturePage : Integer;
      CreatureSelected : Integer;
      OptionsPage : Integer;
      Vertscroll : Boolean;
      Vertscrolldirup : Boolean;
      Horizscroll : Boolean;
      Horizscrolldirleft : Boolean;
      Autorecreate : Boolean;
      Evolution : Boolean;
      Vertscrollstep : Integer;
      vertlastsaverpos  : Integer;
      Horizscrollstep : Integer;
      Horizlastsaverpos  : Integer;
      saverdelay : Integer;
      Autorecreatestableiterations : Integer;
      LastCreatCount : Integer;
      NoStableIterations : Integer;
      TimerTick : Integer;
      MaximumNumberOfCreatures : Integer;
      Showlegend : boolean;
      ShowCensus : boolean;
      ShowHistory : boolean;
      ShowActivity : boolean;
      ShowLine : boolean;
      Backgroundcolor : tcolor;
      Textcolor : tcolor;
      Linecolor : tcolor;
    end;

    PCreatureProperties = ^tCreatureProperties;
    tCreatureProperties = record
      Geneset : Integer;
      Influencedistance : Integer;
      Numberchildren : Integer;
      Minenergy : Integer;
      Maxenergy : Integer;
      Energy : Integer;
      Stepsize : Integer;
      Foodlist : String;
      Startingcount : Integer;
      Displayname : String;
      Description : String;
      Bitmapindex : Integer;
      HistColor  : String;
      HistColorVal : TColor;
      Showsex : Boolean;
      Showenergy : Boolean;
      Showactivity : Boolean;
      Showpartner : Boolean;
      GraphiC : tbitmap;
    end;
    TCreatureStores = array[GSOgre..GSBlueBird] of tCreatureProperties;

const
    AnimalStateStrings : TAnimalStateStrings = ('Living',
                                                'Breeding',
                                                'Being Eaten',
                                                'Eating',
                                                'Competing');
    MouseMoveResetTime = 5000;
    MouseMovesThreshold  = 3;
    designsreenwidth = 1024;
    maxtickspeed = 20;

   tl = 70;  {text length}
   stl = 53;  {short text length}
   ctl = 30; {count text length}
   h0 = 5;
   m1 = 18;
   m2 = 10;
   hgap = 2; {GP Horiz Gap}
   d8 = 55; {Iteration col}
   d1 = 55; {census text left}
   d6 = 2; {Hist key line left}
   d7 = 12; {Hist key line rh}
   d5 = 36; { Graphic left}
   d2 = 16;   {count left}
   d3 = 140; {male left}
   d4 = 120; {fem left}
   dh = 5;
   ll = 2;  {legend left}
   msecspersec = 1000;
   msecspermn = msecspersec*60;
   msecsperhr = msecspermn*60;

Var
        SaverOptions : tSaverOptions;
        SpareCanvases : TSpareCanvases;
        AnimalStatePics : TAnimalStatePics;
        SexPics : TSexPics;
        CreatureStores : TCreatureStores;

        MaleCreatureCensus, FeMaleCreatureCensus : TCreatureCensus;
        CreatureCensus : PCreatureCensus;
	ReincarnationList, CensusSortList, HistoryList, BreadCreatureList : TList;

        imagelist : timagelist;

        stdrect : trect;
        drect, srect : trect;
        drect2, srect2 : trect;
        vdrect, vsrect : trect;
        vdrect2, vsrect2 : trect;

        ParamHandle : THandle;
        ConfigParent : hWnd;

        varclientwidth,  varclientheight : integer;
        SaverMode : Integer;
        dx2, dy, dx : integer;
        maxtick : integer;
        pi360 : integer;
        pmy, pmx, my, mx : integer;
        CurrIteration : integer;
        CensusSize : integer;
        HistMult, histdeltax, HistPointCcount : integer;
        BaseRHpanelwidth, RHpanelwidth : integer;
        rdh,rd1,rd2,rd3,rd4,rd5,rd6,rd7,rd8 : integer;
        paintcount, restarts, eatenCount, deadcount, breadcount : integer;

        ScreenSaveUsePassword, IniDataLoadedOK, didnotbreed, IsInSaverPreviewMode : boolean;
        isWin9X, stopping, freebmp : boolean;
        Runstring : string;

        SysDir:String;
{        OSVerNoPlatformId:DWORD;}

procedure GetOSandSysdir;
Function OKPassword : boolean;
procedure ExecSetPwd;
procedure GetSaverMode;
Procedure ReadRegistryForPasswordSetting;

procedure FreeBMPArrays;
procedure InitBMPArrays;
procedure CopyBmpArrayWithBackGr(pBackGroundColor : tcolor; srcindex : integer; var ABMPArray : Array of graphics.tbitmap; invert : boolean);
procedure SetBmpArrayDims(px, py : integer; var ABMPArray : Array of graphics.tbitmap);
procedure SetBmpArrayBackGroundColor(pBackGroundColor : tcolor; var ABMPArray : Array of graphics.tbitmap);
procedure SetBmpArrayFontColor(pFontColor : tcolor; var ABMPArray : Array of graphics.tbitmap);
Procedure ReadRegistry;
Procedure WriteRegistry;
Procedure SaveToINI(aIniFile : TRegIniFile);
Procedure LoadFromINI(aIniFile : TRegIniFile);

procedure CopyStdBmpWithBackGr(pBackGroundColor : tcolor; srcindex : integer; destbmp : graphics.tbitmap);
Function TickDeltaToTimeStr(adelta : integer) : string;
Function myPtInRect( ARECT :TRECt; ApT : TPOINT) : BOOLEAN;
procedure MyDraw(aCanvas : TCanvas; x, y : integer; abmp : graphics.tbitmap);

{$I DefCreat.inc}  {Include file for deafult creature properties}

Implementation
uses
      dmodule;

{$I ResStrng.inc} {Include file for resource strings for registry keys}

Function TickDeltaToTimeStr(adelta : integer) : string;
Var
   elt, hr, mn, sc : integer;

begin
   hr := adelta div msecsperhr;
   elt := (hr * msecsperhr);
   mn := (adelta - elt) div msecspermn;
   elt := elt+(mn*msecspermn);
   sc := (adelta - elt) div msecspersec;
   result := format('%SH %SM %SS',[inttostr(hr),inttostr(mn),inttostr(sc)]);
end;

Function myPtInRect( ARECT :TRECt; ApT : TPOINT) : BOOLEAN;

begin
     with arect do begin
       result := (ApT.x >= Left ) and
                 (ApT.x <= right) and
                 (ApT.y >= top ) and
                 (ApT.y <= bottom);
     end;
end;

procedure MyDraw(aCanvas : TCanvas; x, y : integer; abmp : graphics.tbitmap);

begin
    aCanvas.CopyRect(Rect(x,y, x+dx2, y+dx2), abmp.Canvas, stdrect);
end;

procedure CopyStdBmpWithBackGr(pBackGroundColor : tcolor; srcindex : integer; destbmp : graphics.tbitmap);
var
  abmp : graphics.tbitmap;

begin
    abmp := graphics.tbitmap.create;
    abmp.transparent := true;
    imagelist.getbitmap(srcindex,  abmp);
    destbmp.width := abmp.width;
    destbmp.height := abmp.height;
    destbmp.Canvas.brush.color := pBackGroundColor;
    destbmp.Canvas.FillRect(stdRect);
    destbmp.Canvas.draw( 0, 0, abmp);
    abmp.free;
end;

Procedure LoadFromINI(aIniFile : TRegIniFile);
var
  lc : integer;
  astr : string;

begin
  With aIniFile do begin
    with SaverOptions do begin
      TimerTick := ReadInteger(Ini_SaverOptions, Ini_TimerTick, DefSaverOptions.TimerTick);
      MaximumNumberOfCreatures := ReadInteger(Ini_SaverOptions, Ini_MaximumNumberOfCreatures, DefSaverOptions.MaximumNumberOfCreatures);
      Showlegend := Readbool(Ini_SaverOptions, Ini_Showlegend, DefSaverOptions.Showlegend);
      ShowCensus := Readbool(Ini_SaverOptions, Ini_ShowCensus, DefSaverOptions.ShowCensus);
      ShowHistory := Readbool(Ini_SaverOptions, Ini_ShowHistory, DefSaverOptions.ShowHistory);
      ShowActivity := Readbool(Ini_SaverOptions, Ini_ShowActivity, DefSaverOptions.ShowActivity);
      ShowLine := Showlegend or ShowCensus or ShowHistory or ShowActivity;
      Backgroundcolor := ReadInteger(Ini_SaverOptions, Ini_Backgroundcolor, DefSaverOptions.Backgroundcolor);
      Textcolor := ReadInteger(Ini_SaverOptions, Ini_Textcolor, DefSaverOptions.Textcolor);
      Linecolor := ReadInteger(Ini_SaverOptions, Ini_Linecolor, DefSaverOptions.Linecolor);
      DialogPage := ReadInteger(Ini_SaverOptions, Ini_DialogPage, DefSaverOptions.DialogPage);
      CreaturePage := ReadInteger(Ini_SaverOptions, Ini_CreaturePage, DefSaverOptions.CreaturePage);
      OptionsPage := ReadInteger(Ini_SaverOptions, Ini_OptionsPage, DefSaverOptions.OptionsPage);
      CreatureSelected := ReadInteger(Ini_SaverOptions, Ini_CreatureSelected, DefSaverOptions.CreatureSelected);
      Vertscroll := ReadBool(Ini_SaverOptions, Ini_Vertscroll, DefSaverOptions.Vertscroll );
      Vertscrollstep := ReadInteger(Ini_SaverOptions, Ini_Vertscrollstep, DefSaverOptions.Vertscrollstep);
      Vertscrolldirup := ReadBool(Ini_SaverOptions, Ini_Vertscrolldirup, DefSaverOptions.Vertscrolldirup);
      Horizscroll := ReadBool(Ini_SaverOptions, Ini_Horizscroll, DefSaverOptions.Horizscroll);
      Horizscrollstep := ReadInteger(Ini_SaverOptions, Ini_Horizscrollstep, DefSaverOptions.Horizscrollstep);
      saverdelay := ReadInteger(Ini_SaverOptions, Ini_saverdelay, DefSaverOptions.saverdelay);
      Horizscrolldirleft := ReadBool(Ini_SaverOptions, Ini_Horizscrolldirleft, DefSaverOptions.Horizscrolldirleft);
      Autorecreate := ReadBool(Ini_SaverOptions, Ini_Autorecreate, DefSaverOptions.Autorecreate);
      Autorecreatestableiterations := ReadInteger(Ini_SaverOptions, Ini_Autorecreatestableiterations, DefSaverOptions.Autorecreatestableiterations);
      Evolution := ReadBool(Ini_SaverOptions, Ini_Evolution, DefSaverOptions.Evolution);
    end;
    for lc := GSOgre to GSBlueBird do begin
        astr := format(Ini_Properties, [inttostr(lc)]);
        with CreatureStores[lc] do begin
          Geneset :=  DefCreatureStores[lc].geneset;
          Influencedistance := ReadInteger(astr, Ini_Influencedistance, DefCreatureStores[lc].Influencedistance);
          Numberchildren := ReadInteger(astr, Ini_Numberofchildren, DefCreatureStores[lc].Numberchildren);
          Minenergy := ReadInteger(astr, Ini_Minenergy, DefCreatureStores[lc].Minenergy);
          Maxenergy := ReadInteger(astr, Ini_Maxenergy, DefCreatureStores[lc].Maxenergy);
          Energy := ReadInteger(astr, Ini_Energy, DefCreatureStores[lc].Energy);
          Stepsize := ReadInteger(astr, Ini_Stepsize, DefCreatureStores[lc].Stepsize);
          Startingcount := ReadInteger(astr,  Ini_Startingcount,((Screen.width * DefCreatureStores[lc].Startingcount) div designsreenwidth));
          Displayname := ReadString(astr,  Ini_Displayname,                DefCreatureStores[lc].Displayname               );
          Description := ReadString(astr,  Ini_Description,                DefCreatureStores[lc].Description               );
          Histcolor := ReadString(astr,  Ini_Histcolor,                    DefCreatureStores[lc].Histcolor                 );
          try
            if identtocolor(Histcolor, Bitmapindex) then HistColorVal := tcolor(Bitmapindex)
                                                    else HistColorVal := stringtocolor(Histcolor);
          except
            HistColorVal := clAqua;
          end;
          Showsex := ReadBool(astr,  Ini_Showsex, True);
          Bitmapindex := ReadInteger(astr,  Ini_Bitmapindex,               DefCreatureStores[lc].Bitmapindex               );
          Showenergy := ReadBool(astr,  Ini_Showenergy, True);
          Showactivity := ReadBool(astr,  Ini_Showactivity, True);
          Showpartner := ReadBool(astr,  Ini_Showpartner, True);
          Foodlist := ReadString(astr, Ini_Foodlist, DefCreatureStores[lc].Foodlist);
          if freebmp then begin
            GraphiC := tbitmap.create;
          end;
        end;
    end;
  end;
end;

Procedure ReadRegistryForPasswordSetting;
var
  aRegistry : TRegistry;

begin
   aRegistry := TRegistry.create;
   try
   if aRegistry.OpenKey('Control Panel\desktop', false) then begin
      if aRegistry.ValueExists('ScreenSaveUsePassword') then ScreenSaveUsePassword :=  (aRegistry.ReadInteger('ScreenSaveUsePassword') <> 0)
                                                        else ScreenSaveUsePassword :=  false;
   end;
   finally
     aRegistry.free;
   end;
end;

Procedure ReadRegistry;
var
  aIniFile : TRegIniFile;

begin
  aIniFile := TRegIniFile.create(RegKeyName);
try
   Try
     LoadFromINI(aIniFile);
     IniDataLoadedOK := true;
   Except
     IniDataLoadedOK := false;
   end;
finally
    aIniFile.free;
end;
end;

Procedure WriteRegistry;
var
  aIniFile : TRegIniFile;

begin
  aIniFile := TRegIniFile.create(RegKeyName);
  aIniFile.lazywrite := false;
try
  SaveToINI(aIniFile);
finally
    aIniFile.free;
end;
end;

Procedure SaveToINI(aIniFile : TRegIniFile);
var
  lc : integer;
  astr : string;

begin
  With aIniFile do begin
    with SaverOptions do begin
      WriteInteger(Ini_SaverOptions, Ini_TimerTick, TimerTick);
      WriteInteger(Ini_SaverOptions, Ini_MaximumNumberOfCreatures, MaximumNumberOfCreatures);
      Writebool(Ini_SaverOptions, Ini_Showlegend, Showlegend);
      Writebool(Ini_SaverOptions, Ini_ShowCensus, ShowCensus);
      Writebool(Ini_SaverOptions, Ini_ShowHistory, ShowHistory);
      Writebool(Ini_SaverOptions, Ini_ShowActivity, ShowActivity);
      WriteInteger(Ini_SaverOptions, Ini_Backgroundcolor, Backgroundcolor);
      WriteInteger(Ini_SaverOptions, Ini_Textcolor, Textcolor);
      WriteInteger(Ini_SaverOptions, Ini_Linecolor, Linecolor);
      WriteInteger(Ini_SaverOptions, Ini_DialogPage, DialogPage);
      WriteInteger(Ini_SaverOptions, Ini_CreaturePage, CreaturePage);
      WriteInteger(Ini_SaverOptions, Ini_OptionsPage, OptionsPage);
      WriteInteger(Ini_SaverOptions, Ini_CreatureSelected, CreatureSelected);
      WriteBool(Ini_SaverOptions, Ini_Vertscroll, Vertscroll);
      WriteInteger(Ini_SaverOptions, Ini_Vertscrollstep, Vertscrollstep);
      WriteBool(Ini_SaverOptions, Ini_Vertscrolldirup, Vertscrolldirup);
      WriteBool(Ini_SaverOptions, Ini_Horizscroll, Horizscroll);
      WriteInteger(Ini_SaverOptions, Ini_Horizscrollstep, Horizscrollstep);
      WriteInteger(Ini_SaverOptions, Ini_saverdelay, saverdelay);
      WriteBool(Ini_SaverOptions, Ini_Horizscrolldirleft, Horizscrolldirleft);
      WriteBool(Ini_SaverOptions, Ini_Autorecreate, Autorecreate);
      WriteInteger(Ini_SaverOptions, Ini_Autorecreatestableiterations, Autorecreatestableiterations);
      WriteBool(Ini_SaverOptions, Ini_Evolution, Evolution);
    end;
    for lc := GSOgre to GSBlueBird do begin
        astr := format(Ini_Properties, [inttostr(lc)]);
        with CreatureStores[lc] do begin
          WriteInteger(astr, Ini_Geneset, Geneset);
          WriteInteger(astr, Ini_Influencedistance, Influencedistance);
          WriteInteger(astr, Ini_Numberofchildren, Numberchildren);
          WriteInteger(astr, Ini_Minenergy, Minenergy);
          WriteInteger(astr, Ini_Maxenergy, Maxenergy);
          WriteInteger(astr, Ini_Energy, Energy);
          WriteInteger(astr, Ini_Stepsize, Stepsize);
          WriteString(astr, Ini_Foodlist, Foodlist);
          WriteInteger(astr,  Ini_Startingcount, Startingcount);
          WriteString(astr,  Ini_Displayname, Displayname);
          WriteString(astr,  Ini_Description, Description);
          WriteInteger(astr,  Ini_Bitmapindex, Bitmapindex);
          WriteBool(astr,  Ini_Showsex, Showsex);
          WriteBool(astr,  Ini_Showenergy, Showenergy);
          WriteBool(astr,  Ini_Showactivity, Showactivity);
          WriteBool(astr,  Ini_Showpartner, Showpartner);
          WriteString(astr,  Ini_Histcolor, Histcolor);
          if freebmp and assigned(graphic) then GraphiC.free;
        end;
    end;
  end;
end;

Procedure InitBMPArray(var ABMPArray : Array of graphics.tbitmap);
Var
   lc, mc : integer;

begin
   mc := high(ABMPArray);
   for lc := 0 to mc do begin
      ABMPArray[lc] := graphics.tBitmap.create;
   end;
end;

Procedure FreeBMPArray(var ABMPArray : Array of graphics.tbitmap);
Var
   lc, mc : integer;

begin
   mc := high(ABMPArray);
   for lc := 0 to mc do begin
      ABMPArray[lc].free;
   end;
end;

procedure SetBmpArrayDims(px, py : integer; var ABMPArray : Array of graphics.tbitmap);
Var
   lc, mc : integer;

begin
   mc := high(ABMPArray);
   for lc := 0 to mc do begin
      with ABMPArray[lc] do begin
          width := px;
          height := py;
      end;
   end;
end;

procedure SetBmpArrayBackGroundColor(pBackGroundColor : tcolor; var ABMPArray : Array of graphics.tbitmap);
Var
   lc, mc : integer;

begin
   mc := high(ABMPArray);
   for lc := 0 to mc do begin
      with ABMPArray[lc] do begin
          canvas.brush.color := pBackGroundColor;
      end;
   end;
end;

procedure SetBmpArrayFontColor(pFontColor : tcolor; var ABMPArray : Array of graphics.tbitmap);
Var
   lc, mc : integer;

begin
   mc := high(ABMPArray);
   for lc := 0 to mc do begin
      with ABMPArray[lc] do begin
          canvas.font.color := pFontColor;
      end;
   end;
end;

procedure CopyBmpArrayWithBackGr(pBackGroundColor : tcolor; srcindex : integer; var ABMPArray : Array of graphics.tbitmap; invert : boolean);
Var
   lc, mc : integer;

begin
   mc := high(ABMPArray);
   for lc := 0 to mc do begin
      CopyStdBmpWithBackGr( pBackGroundColor, srcindex, ABMPArray[lc]);
      if invert then dec( srcindex)
                else inc( srcindex);
   end;
end;

procedure InitBMPArrays;

begin
        InitBMPArray(SpareCanvases);
        InitBMPArray(AnimalStatePics);
        InitBMPArray(SexPics);
end;

procedure FreeBMPArrays;

begin
        FreeBMPArray(SpareCanvases);
        FreeBMPArray(AnimalStatePics);
        FreeBMPArray(SexPics);
end;

procedure GetOSandSysdir;
var
    NewLength:Integer;
    OSVer:TOSVersionInfo;

begin
  OSVer.dwOSVersionInfoSize := SizeOf(OSVer);
  GetVersionEx(OSVer);
  isWin9X := (OSVer.dwPlatformID = VER_PLATFORM_WIN32_WINDOWS);
  if isWin9X then begin
       SetLength(SysDir,MAX_PATH);
       NewLength := GetSystemDirectory (PChar(SysDir),MAX_PATH);
       SetLength(SysDir,NewLength);
       SysDir := addbackslash(SysDir);
  end;
end;


Function OKPassword : boolean;
var
  hLib:THandle;
  P : function(Parent:THandle):Boolean; stdcall;

begin
     hLib:=LoadLibrary(pchar(SysDir+'PASSWORD.CPL'));
     result := (hLib = 0);
     if not(result) then begin //show the password verification dialog
           P:=GetProcAddress(hLib,'VerifyScreenSavePwd');
           result := P(ParamHandle);
           FreeLibrary(hLib); //unload PASSWORD.CPL
     end;
end;

procedure ExecSetPwd;
var
   hLib:THandle;
   P:function (a:PChar; ParentHandle:THandle; b,c:Integer):Integer; stdcall;

begin
  if isWin9X then begin
       hLib:=LoadLibrary(pchar(SysDir+'MPR.DLL'));
       if (hLib <> 0) then begin
            P:=GetProcAddress(hLib,'PwdChangePasswordA');
            if Assigned(P) then P('SCRSAVE',ParamHandle,0,0);
            FreeLibrary(hLib);
       end;
  end;
end;

procedure GetSaverMode;
var
  pc : integer;
  Param1, Param2 : string;

    procedure SetParamHandle;

    begin
      try
        ParamHandle:=StrToInt(Param2);
      except
        ParamHandle:=0;
      end;
    end;

begin
  ConfigParent:=0; //no modal dialog if not called via /c
  ParamHandle:=0;
  IsInSaverPreviewMode := false;
  pc := ParamCount;
  if (pc = 0) then SaverMode:=savModeConfigureStd
  else begin
    Param1:=UpperCase(ParamStr(1));
    Delete(Param1,1,1); //remove the first character, usually a "/" or a "-"
    if (pc = 2) then Param2 := ParamStr(2);
    if (Pos('C',Param1)=1) then begin //In NT you get /C:windowhandle? so only test if first character is C
      SaverMode := savModeConfigure;
      ConfigParent := GetForegroundWindow;
    end
    else if (Param1='A') and (pc > 1) then begin //there must be a window handle
          SaverMode:=savModeSetPwd;
          SetParamHandle;
    end
    else if (Param1='P') and (pc > 1) then begin //there must be a window handle
          SaverMode:=savModePreview;
          IsInSaverPreviewMode := true;
          SetParamHandle;
    end
    else begin //I need to give back the focus the currently active
         SaverMode:= savModeExecute;
         ConfigParent:= GetForegroundWindow;
    end; //window after terminating the full screen saver
  end;
end;

{ End of code  }
end.

